function DisplayMenu {
Clear-Host
Write-Host @"
+===============================================+
|  EDIUS X (10.3x) EH Service Tool Menu         | 
+===============================================+
|                                               |
|    1) Stop EH services                        |
|    2) Start EH services                       |
|    3) Restart EH services                     |
|    4) Hub Diagnostics                         |          
|    5) Reset EH port number to default         |
|    6) Run Command Prompt (in new window)      |
|    7) Restart OS                              |
|    8) EXIT                                    |
|                                               |
+===============================================+

"@

$MENU = Read-Host "Select option"
Switch ($MENU)
{
1 {
#OPTION1 - Stop EH services


$service = (&{
cls	
Write-Host "Detecting EH services"
$i=8
while ($i -le 8) {
	$service = (Get-Service -Name EH* | Where-Object { $_.Status -eq "Running" })
	Start-Sleep -m 300
      Stop-Service $service
	$i +=1
	}
      Write-Host "Stopping EH services started successfully."
	Start-Sleep 3
	if ($service -eq $null)
	{
		Write-Host "All or part of EH service is not detected. Abortted. No service detected or they have already been stopped. Identify which occurs in the Task Manager - Process aborted." -ForegroundColor Red
		Start-Sleep 1
		taskmgr
		pause
		return $null
	}

})
cls
DisplayMenu
}

2 {
#OPTION2 - Start EH services
$ErrorActionPreference = "silentlycontinue"

$service = (&{
cls	
Write-Host "Detecting EH services"
$i=8
while ($i -le 8) {
	$service = (Get-Service -Name EH* | Where-Object { $_.Status -eq "Stopped" })
	Start-Sleep -m 300
      Start-Service $service
	$i +=1
	}
      Write-Host "Starting EH services started successfully."
	Start-Sleep 3
	if ($service -eq $null)
	{
		Write-Host "All or part of EH service is not detected. Abortted. No service detected or they have already been started. Identify which occurs in the Task Manager - Process aborted." -ForegroundColor Red
		Start-Sleep 1
		taskmgr
		pause
		return $null
	}


})
cls
DisplayMenu
}

3 {
#OPTION3 - Restart EH services
$ErrorActionPreference = "silentlycontinue"

$service = (&{
cls	
Write-Host "Detecting EH services"
$i=8
while ($i -le 8) {
	$service = (Get-Service -Name EH* | Where-Object { $_.Status -eq "Running" })
	Start-Sleep -m 300
      Stop-Service $service
	$i +=1
	}
      Write-Host "Stopping EH services successfully. The services will start after 10 seconds."
	Start-Sleep 10
	if ($service -eq $null)
	{
		Write-Host "All or part of EH service is not detected. Abortted. No service detected or they have already been started. Identify which occurs in the Task Manager - Process aborted." -ForegroundColor Red
		Start-Sleep 1
		taskmgr
		pause
		return $null
	}
$i=8
while ($i -le 8) {
	$service = (Get-Service -Name EH* | Where-Object { $_.Status -eq "Stopped" })
	Start-Sleep -m 300
      Start-Service $service
	$i +=1
	}
      Write-Host "Starting EH services started successfully."
	Start-Sleep 3
	if ($service -eq $null)
	{
		Write-Host "All or part of EH service is not detected. Abortted. No service detected or they have already been started. Identify which occurs in the Task Manager - Process aborted." -ForegroundColor Red
		Start-Sleep 1
		taskmgr
		pause
		return $null
	}


})
cls
DisplayMenu
}

4 {
#OPTION4 - Hub Diagnostics (EDIUS X)
cls

$date = Get-Date -Format "yyyyMMddhhmmss";
$dest = Join-Path C:\Ehub_Diag ("EdiusHubDiagResult_" + $date + ".txt")

$exist = test-path "C:\Program Files\Grass Valley\Edius Hub\Tools\EdiusHubDiagnostics.exe"
$checkdest = test-path C:\Ehub_Diag
if ($checkdest -ne $true)
{
New-item C:\Ehub_Diag -Itemtype directory -force
}
Start-Sleep -m 300
if ($exist -eq $true)
{
Write-Host "EDIUS Hub Diagnostics tool is now running. It may take few minutes."
& "C:\Program Files\Grass Valley\Edius Hub\Tools\EdiusHubDiagnostics.exe" > $dest
Write-Host "Diagnostic completed. Diag result is exported as" $dest"."
pause
cls
DisplayMenu
} 
if ($exist -eq $false)
{
Write-Host "Edius Hub Diagnostics tool does not exist. Ensure that EDIUS X 10.3x or later has been correctly installed." -ForegroundColor Red
pause
cls
DisplayMenu
}
}


5 {
#OPTION5 - Reset EH service ports# to default
cls
Write-Host "Reset the port numbers used by EH services to software default.`nBelow are current condition."
& "C:\Program Files\Grass Valley\EDIUS Hub\Tools\EdiusHubPortConfig.exe" show
$input = Read-Host "Did you confirm no reservation of port number?"
switch ($input) {
    "y" {
        Write-host "Port number is now resetting to default."

        $service = (&{
	  cls	
	  Write-Host "Stopping EH services"
	  $i=8
	  while ($i -le 8) {
		$service = (Get-Service -Name EH* | Where-Object { $_.Status -eq "Running" })
		Start-Sleep -m 300
      	  	Stop-Service $service
      	  $i +=1
	}
        Write-Host "Stopping EH services successfully."
	
	if ($service -eq $null)
	{
	   Write-Host "All or part of EH service is not detected.`nNo service detected or they have already been stopped. Identify which occurs in the Task Manager - Process aborted." -ForegroundColor Red
		Start-Sleep 1
		taskmgr
		pause
		return $null
	}
	})
	}

     "n" {
	 Write "Reset process aborted. Will back to top menu automatically."
         sleep 5
         exit
         }
}
Start-Sleep 3
Write-Host "Port numbers are now resetting..."
	$delitem = Get-ChildItem -Path "C:\ProgramData\Grass Valley\EDIUS Hub" -Recurse |Where-Object {-not $_.PSIsContainer -and $_.Name -eq "appsettings.json"}|Select-Object FullName
	$delitem = $delitem.fullname
	Start-Sleep -m 300
	Write-host $delitem
	Write-Host "Resetting port numbers successfully. EH service is now starting..."
        if ($delitem -eq $null)
        {
	Write-Host "The files should be deleted are not found.Reset Chorus Hub manually." -ForegroundColor Red
	Write-Host "Will back to top menu."
	Start-Sleep 3
        cls
        Displaymenu
        }
	$service = (&{ 
	$i=8
	while ($i -le 8) {
	  $service = (Get-Service -Name EH* | Where-Object { $_.Status -eq "Stopped" })
	  Start-Sleep -m 300
          Start-Service $service
	$i +=1
	}
          Write-Host "Resetting port number successfully.Will back to top menu automatically."
	  Start-Sleep 5
                    
	if ($service -eq $null)
	{
		Write-Host "All or part of EH service is not detected. Abortted. No service detected or they have already been started. Identify which occurs in the Task Manager - Process aborted." -ForegroundColor Red
		Start-Sleep 1
		taskmgr
		pause
		return $null
	}
})
cls
DisplayMenu
  
}


6 {
#OPTION6 - Run Command Prompt
cls
start "cmd"
Write-Host "Press Enter key to back to the menu.`n(Command prompt window won't close automatically)"
pause
cls
DisplayMenu
}

7 {
#OPTION9 - Restart OS
cls
Write-Host "Ensure that you have completed saving required data`nOnce ready, press Enter key." -ForegroundColor Red
pause
Write-Host "PC is now restarting..."
Start-Sleep 5
Restart-Computer -Force
}

8 {
#OPTION10 - EXIT
Write-Host "Bye"
Start-Sleep 2
Break
}


default {
#DEFAULT OPTION
Write-Host "Option not available. Select valid option." -ForegroundColor Red
Start-Sleep -Seconds 2
cls
DisplayMenu
}
}
}
DisplayMenu